searchNodes=[{"doc":"AvroEx is a library for encoding and decoding data with Avro schemas. Supports parsing schemas, encoding data, and decoding data. For encoding and decoding, the following type chart should be referenced: Avro Types Elixir Types boolean boolean integer integer long integer float decimal double decimal bytes binary string String.t, atom null nil Record map Enum String.t, atom (corresponding to the enum's symbol list)","ref":"AvroEx.html","title":"AvroEx","type":"module"},{"doc":"Given an encoded message and its accompanying schema, decodes the message. iex&gt; schema = AvroEx . decode_schema! ( &quot;boolean&quot; ) iex&gt; AvroEx . decode ( schema , &lt;&lt; 1 &gt;&gt; ) { :ok , true }","ref":"AvroEx.html#decode/2","title":"AvroEx.decode/2","type":"function"},{"doc":"Same as decode/2, but returns raw decoded value. Raises AvroEx.DecodeError.t/0 on error. Examples iex&gt; schema = AvroEx . decode_schema! ( &quot;string&quot; ) iex&gt; encoded = AvroEx . encode! ( schema , &quot;hello&quot; ) iex&gt; AvroEx . decode! ( schema , encoded ) &quot;hello&quot;","ref":"AvroEx.html#decode!/2","title":"AvroEx.decode!/2","type":"function"},{"doc":"Given an Elixir or JSON-encoded schema, parses the schema and returns a AvroEx.Schema.t/0 struct representing the schema. Errors for invalid JSON, invalid schemas, and bad name references. Options :strict - whether to strictly validate the schema, defaults to false . Recommended to turn this on for locally owned schemas, but not for interop with external schemas. Examples iex&gt; AvroEx . decode_schema ( &quot;string&quot; ) { :ok , % AvroEx.Schema { schema : % AvroEx.Schema.Primitive { type : :string } } } iex&gt; json = ~S({&quot;fields&quot;:[{&quot;name&quot;:&quot;a&quot;,&quot;type&quot;:&quot;string&quot;}],&quot;name&quot;:&quot;my_type&quot;,&quot;type&quot;:&quot;record&quot;}) iex&gt; { :ok , % Schema { schema : record } } = AvroEx . decode_schema ( json ) iex&gt; match? ( % Record { } , record ) true","ref":"AvroEx.html#decode_schema/2","title":"AvroEx.decode_schema/2","type":"function"},{"doc":"Same as AvroEx.decode_schema/1 , but raises an exception on failure instead of returning an error tuple. Examples iex&gt; AvroEx . decode_schema! ( &quot;int&quot; ) % AvroEx.Schema { schema : % AvroEx.Schema.Primitive { type : :int } }","ref":"AvroEx.html#decode_schema!/2","title":"AvroEx.decode_schema!/2","type":"function"},{"doc":"Checks to see if the given data is encodable using the given schema. Helpful for unit testing. iex&gt; AvroEx . encodable? ( % Schema { schema : % Primitive { type : :string } } , &quot;wut&quot; ) true iex&gt; AvroEx . encodable? ( % Schema { schema : % Primitive { type : :string } } , 12345 ) false","ref":"AvroEx.html#encodable?/2","title":"AvroEx.encodable?/2","type":"function"},{"doc":"Given AvroEx.Schema.t/0 and term() , takes the data and encodes it according to the schema. Examples iex&gt; schema = AvroEx . decode_schema! ( &quot;int&quot; ) iex&gt; AvroEx . encode ( schema , 1234 ) { :ok , &lt;&lt; 164 , 19 &gt;&gt; }","ref":"AvroEx.html#encode/2","title":"AvroEx.encode/2","type":"function"},{"doc":"Same as encode/2 , but returns the encoded value directly. Raises AvroEx.EncodeError.t/0 on error. Examples iex&gt; schema = AvroEx . decode_schema! ( &quot;boolean&quot; ) iex&gt; AvroEx . encode! ( schema , true ) &lt;&lt; 1 &gt;&gt;","ref":"AvroEx.html#encode!/2","title":"AvroEx.encode!/2","type":"function"},{"doc":"Encodes the given schema to JSON Options canonical - Encodes the schema into its Parsing Canonical Form , default false Examples iex&gt; schema = AvroEx . decode_schema! ( %{ &quot;type&quot; =&gt; &quot;int&quot; , &quot;logicalType&quot; =&gt; &quot;date&quot; } ) iex&gt; AvroEx . encode_schema ( schema ) ~S({&quot;type&quot;:&quot;int&quot;,&quot;logicalType&quot;:&quot;date&quot;}) iex&gt; schema = AvroEx . decode_schema! ( %{ &quot;type&quot; =&gt; &quot;int&quot; , &quot;logicalType&quot; =&gt; &quot;date&quot; } ) iex&gt; AvroEx . encode_schema ( schema , canonical : true ) ~S(&quot;int&quot;)","ref":"AvroEx.html#encode_schema/2","title":"AvroEx.encode_schema/2","type":"function"},{"doc":"","ref":"AvroEx.html#named_type/2","title":"AvroEx.named_type/2","type":"function"},{"doc":"","ref":"AvroEx.html#parse_schema/1","title":"AvroEx.parse_schema/1","type":"function"},{"doc":"","ref":"AvroEx.html#parse_schema!/1","title":"AvroEx.parse_schema!/1","type":"function"},{"doc":"","ref":"AvroEx.html#t:encoded_avro/0","title":"AvroEx.encoded_avro/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.html","title":"AvroEx.Schema","type":"module"},{"doc":"","ref":"AvroEx.Schema.html#encodable?/2","title":"AvroEx.Schema.encodable?/2","type":"function"},{"doc":"","ref":"AvroEx.Schema.html#encodable?/3","title":"AvroEx.Schema.encodable?/3","type":"function"},{"doc":"The fully-qualified name of the type Examples iex&gt; full_name ( % Primitive { type : &quot;string&quot; } ) nil iex&gt; full_name ( % Record { name : &quot;foo&quot; , namespace : &quot;beam.community&quot; } ) &quot;beam.community.foo&quot; iex&gt; full_name ( % Record { name : &quot;foo&quot; } , &quot;top.level.namespace&quot; ) &quot;top.level.namespace.foo&quot;","ref":"AvroEx.Schema.html#full_name/2","title":"AvroEx.Schema.full_name/2","type":"function"},{"doc":"The namespace of the given Schema type Examples iex&gt; namespace ( % Primitive { type : :string } ) nil iex&gt; namespace ( % Record { name : &quot;MyRecord&quot; } , &quot;namespace&quot; ) &quot;namespace&quot; iex&gt; namespace ( % Record { name : &quot;MyRecord&quot; , namespace : &quot;inner&quot; } , &quot;namespace&quot; ) &quot;inner&quot; iex&gt; namespace ( % Record { name : &quot;qualified.MyRecord&quot; , namespace : &quot;inner&quot; } , &quot;namespace&quot; ) &quot;qualified&quot;","ref":"AvroEx.Schema.html#namespace/2","title":"AvroEx.Schema.namespace/2","type":"function"},{"doc":"The name of the schema type Examples iex&gt; type_name ( % Primitive { type : &quot;string&quot; } ) &quot;string&quot; iex&gt; type_name ( % Primitive { type : :long , metadata : %{ &quot;logicalType&quot; =&gt; &quot;timestamp-millis&quot; } } ) &quot;timestamp-millis&quot; iex&gt; type_name ( % AvroEnum { name : &quot;switch&quot; , symbols : [ ] } ) &quot;Enum&lt;name=switch&gt;&quot; iex&gt; type_name ( % Array { items : % Primitive { type : &quot;int&quot; } } ) &quot;Array&lt;items=int&gt;&quot; iex&gt; type_name ( % Fixed { size : 2 , name : &quot;double&quot; } ) &quot;Fixed&lt;name=double, size=2&gt;&quot; iex&gt; type_name ( % Union { possibilities : [ % Primitive { type : &quot;string&quot; } , % Primitive { type : &quot;int&quot; } ] } ) &quot;Union&lt;possibilities=string|int&gt;&quot; iex&gt; type_name ( % Record { name : &quot;foo&quot; } ) &quot;Record&lt;name=foo&gt;&quot;","ref":"AvroEx.Schema.html#type_name/1","title":"AvroEx.Schema.type_name/1","type":"function"},{"doc":"","ref":"AvroEx.Schema.html#t:alias/0","title":"AvroEx.Schema.alias/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.html#t:doc/0","title":"AvroEx.Schema.doc/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.html#t:full_name/0","title":"AvroEx.Schema.full_name/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.html#t:json_schema/0","title":"AvroEx.Schema.json_schema/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.html#t:metadata/0","title":"AvroEx.Schema.metadata/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.html#t:name/0","title":"AvroEx.Schema.name/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.html#t:named_type/0","title":"AvroEx.Schema.named_type/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.html#t:namespace/0","title":"AvroEx.Schema.namespace/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.html#t:schema_types/0","title":"AvroEx.Schema.schema_types/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.html#t:t/0","title":"AvroEx.Schema.t/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.Array.html","title":"AvroEx.Schema.Array","type":"module"},{"doc":"","ref":"AvroEx.Schema.Array.html#match?/3","title":"AvroEx.Schema.Array.match?/3","type":"function"},{"doc":"","ref":"AvroEx.Schema.Array.html#t:t/0","title":"AvroEx.Schema.Array.t/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.Context.html","title":"AvroEx.Schema.Context","type":"module"},{"doc":"","ref":"AvroEx.Schema.Context.html#lookup/2","title":"AvroEx.Schema.Context.lookup/2","type":"function"},{"doc":"","ref":"AvroEx.Schema.Context.html#t:t/0","title":"AvroEx.Schema.Context.t/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.DecodeError.html","title":"AvroEx.Schema.DecodeError","type":"exception"},{"doc":"","ref":"AvroEx.Schema.DecodeError.html#new/1","title":"AvroEx.Schema.DecodeError.new/1","type":"function"},{"doc":"","ref":"AvroEx.Schema.DecodeError.html#t:t/0","title":"AvroEx.Schema.DecodeError.t/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.Enum.html","title":"AvroEx.Schema.Enum","type":"module"},{"doc":"","ref":"AvroEx.Schema.Enum.html#match?/3","title":"AvroEx.Schema.Enum.match?/3","type":"function"},{"doc":"","ref":"AvroEx.Schema.Enum.html#t:t/0","title":"AvroEx.Schema.Enum.t/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.Fixed.html","title":"AvroEx.Schema.Fixed","type":"module"},{"doc":"","ref":"AvroEx.Schema.Fixed.html#match?/3","title":"AvroEx.Schema.Fixed.match?/3","type":"function"},{"doc":"","ref":"AvroEx.Schema.Fixed.html#t:t/0","title":"AvroEx.Schema.Fixed.t/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.Map.html","title":"AvroEx.Schema.Map","type":"module"},{"doc":"","ref":"AvroEx.Schema.Map.html#match?/3","title":"AvroEx.Schema.Map.match?/3","type":"function"},{"doc":"","ref":"AvroEx.Schema.Map.html#t:t/0","title":"AvroEx.Schema.Map.t/0","type":"type"},{"doc":"Functions for handling primitive types in Avro schemas","ref":"AvroEx.Schema.Primitive.html","title":"AvroEx.Schema.Primitive","type":"module"},{"doc":"","ref":"AvroEx.Schema.Primitive.html#t:primitive/0","title":"AvroEx.Schema.Primitive.primitive/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.Primitive.html#t:t/0","title":"AvroEx.Schema.Primitive.t/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.Record.html","title":"AvroEx.Schema.Record","type":"module"},{"doc":"","ref":"AvroEx.Schema.Record.html#match?/3","title":"AvroEx.Schema.Record.match?/3","type":"function"},{"doc":"","ref":"AvroEx.Schema.Record.html#t:t/0","title":"AvroEx.Schema.Record.t/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.Record.Field.html","title":"AvroEx.Schema.Record.Field","type":"module"},{"doc":"","ref":"AvroEx.Schema.Record.Field.html#match?/3","title":"AvroEx.Schema.Record.Field.match?/3","type":"function"},{"doc":"","ref":"AvroEx.Schema.Record.Field.html#t:t/0","title":"AvroEx.Schema.Record.Field.t/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.Reference.html","title":"AvroEx.Schema.Reference","type":"module"},{"doc":"","ref":"AvroEx.Schema.Reference.html#new/1","title":"AvroEx.Schema.Reference.new/1","type":"function"},{"doc":"","ref":"AvroEx.Schema.Reference.html#t:t/0","title":"AvroEx.Schema.Reference.t/0","type":"type"},{"doc":"","ref":"AvroEx.Schema.Union.html","title":"AvroEx.Schema.Union","type":"module"},{"doc":"","ref":"AvroEx.Schema.Union.html#match?/3","title":"AvroEx.Schema.Union.match?/3","type":"function"},{"doc":"","ref":"AvroEx.Schema.Union.html#t:t/0","title":"AvroEx.Schema.Union.t/0","type":"type"},{"doc":"Exceptions in decoding Avro data","ref":"AvroEx.DecodeError.html","title":"AvroEx.DecodeError","type":"exception"},{"doc":"","ref":"AvroEx.DecodeError.html#new/1","title":"AvroEx.DecodeError.new/1","type":"function"},{"doc":"","ref":"AvroEx.DecodeError.html#t:t/0","title":"AvroEx.DecodeError.t/0","type":"type"},{"doc":"Exceptions in encoding Avro data","ref":"AvroEx.EncodeError.html","title":"AvroEx.EncodeError","type":"exception"},{"doc":"","ref":"AvroEx.EncodeError.html#new/1","title":"AvroEx.EncodeError.new/1","type":"function"},{"doc":"","ref":"AvroEx.EncodeError.html#t:t/0","title":"AvroEx.EncodeError.t/0","type":"type"}]